angular.module('mobionicApp.data', [])

// Home Data: Home page configuration
.factory('Data', function(){
    var data = {};
    
    data.items = [
	   { 
            title: 'Technotification',
            icon: 'ion-home',
            note: 'Website',
            url: 'http://www.technotification.com/'
         },

	   { 
            title: 'Latest Posts',
            icon: 'ion-social-rss',
            note: 'Offline Also',
            url: '#/app/posts'
        }, 
		
		
	  { 
            title: 'About Us',
            icon: 'ion-person-stalker',
            note: 'About Us',
            url: 'http://www.technotification.com/about'
        },
        { 
            title: 'Contact Us',
            icon: 'ion-email',
            note: 'Contact Us',
            url: 'http://www.technotification.com/contact'
        },
	   { 
            title: 'Twitter',
            icon: 'ion-social-twitter',
            note: 'Follow Us',
            url: 'http://mobile.twitter.com/@tech9tification'
        },
        { 
            title: 'Facebook',
            icon: 'ion-social-facebook',
            note: 'Like Us',
            url: 'http://facebook.com/technotification'
        },
	  { 
            title: 'Google+',
            icon: 'ion-social-googleplus',
            note: 'Add Us',
            url: 'https://plus.google.com/+Technotification'
        },
        { 
            title: 'Extra',
            icon: 'ion-iphone',
            note: 'For You',
            url: '#/app/plugins'
        },
	   { 
            title: 'Offers',
            icon: 'ion-star',
            note: 'Offers',
            url: 'http://www.technotification.com/newtnoffers'
        },

    ]; 
    
    return data;
})

// Menu Data: Menu configuration
.factory('MenuData', function(){
    var data = {};
    
    data.items = [
        { 
            title: 'Home',
            icon: 'ion-home',
            url: '#/app'
        },       
		{ 
            title: 'Rate Us',
            icon: 'ion-heart',
            url: 'http://bit.ly/1BF1Nd7'
        },
	{ 
            title: 'Developer',
            icon: 'ion-android-contact',
            url: 'http://vickyrao.com'
        },
		        
    ]; 
    
    return data;
})

// Plugins Data: Mobile Plugins configuration
.factory('PluginsData', function(){
    var data = {};
    
    data.items = [
                { 
            title: 'Geolocation',
            icon: 'ion-location',
            note: 'Geolocation API',
            url: '#/app/plugins/geolocation'
        },
        { 
            title: 'Notifications',
            icon: 'ion-alert',
            note: 'Dialogs API',
            url: '#/app/plugins/notifications'
        },
        { 
            title: 'Barcode',
            icon: 'ion-qr-scanner',
            note: 'Barcode Scanner',
            url: '#/app/plugins/barcodescanner'
        }
    ]; 
    
    return data;
})


// About Data: JSON
.factory('AboutData', function($http, $q, AboutStorage) {
    
    var json = 'json/about.json';
    
    var deferred = $q.defer();
    var promise = deferred.promise;
    var data = [];
    var service = {};
    
    service.async = function() {
    $http({method: 'GET', url: json, timeout: 5000}).
    // this callback will be called asynchronously
    // when the response is available.
    success(function(d) {
        data = d.result;
        AboutStorage.save(data);
        deferred.resolve();
    }).
    // called asynchronously if an error occurs
    // or server returns response with an error status.
    error(function() {
        data = AboutStorage.all();
        deferred.reject();
    });
        
    return promise;
        
    };
    
    service.getAll = function() { return data; };

    service.get = function(memberId) { return data[memberId]; };

    return service;
})

// Posts Data: JSON Wordpress Posts configuration
.factory('PostsData', function($http, $q, PostsStorage) {
  /* Set your URL as you can see in the following example */
    // var json = 'http://www.technotification.com/?json=get_recent_posts';
    
    /* With user-friendly permalinks configured */
    var json = 'http://www.technotification.com/api/get_recent_posts?';

    var deferred = $q.defer();
    var promise = deferred.promise;
    var data = [];
    var service = {};
    
    service.async = function() {
    $http({method: 'GET', url: json, timeout: 5000}).
    // this callback will be called asynchronously
    // when the response is available.
    success(function(d) {
        data = d;
        PostsStorage.save(data);
        deferred.resolve();
    }).
    // called asynchronously if an error occurs
    // or server returns response with an error status.
    error(function() {
        data = PostsStorage.all();
        deferred.reject();
    });
        
    return promise;
        
    };
    
    service.getAll = function() { return data; };

    service.get = function(postId) { return data.posts[postId]; };

    return service;
})

// ServerPosts Data: JSON Wordpress Posts configuration with Server Side pagination
.factory('ServerPostsData', function($http, $q, ServerPostsStorage) {
    
    var data = [];
    var service = {};
   
    /* Set your URL as you can see in the following example */
    /* NOTE: In case of the default permalinks, you should add '&' at the end of the url */
    // var json = 'http://www.technotification.com/?json=get_recent_posts&';
    
    /* With user-friendly permalinks configured */
    /* NOTE: In case of the user-friendly permalinks, you should add '?' at the end of the url */
    var json = 'http://www.technotification.com/api/get_recent_posts?';
    
    service.getURL = function() { return json; };
    
    service.setData = function(posts) { data = posts; };

    service.get = function(serverpostId) { return data[serverpostId]; };
    
    return service;
})

// RSS Feeds Data: JSON
.factory('FeedsData', function($http, $q, FeedsStorage) {
    
    var xml = 'http://www.technotification.com/feed';
    var url = 'http://ajax.googleapis.com/ajax/services/feed/load?v=1.0&num=50&callback=JSON_CALLBACK&q=' + encodeURIComponent(xml);
    
    var deferred = $q.defer();
    var promise = deferred.promise;
    var data = [];
    var service = {};
    var entries = []; 
    
    service.async = function() {
    $http({method: 'JSONP', url: url, timeout: 5000}).
    // this callback will be called asynchronously
    // when the response is available.
    success(function(d) {
        data = d;
        FeedsStorage.save(data.responseData.feed);
        entries = data.responseData.feed.entries;
        deferred.resolve();
    }).
    // called asynchronously if an error occurs
    // or server returns response with an error status.
    error(function() {
        data = FeedsStorage.all();
        entries = data.entries;
        deferred.reject();
    });
        
    return promise;
        
    };
    
    service.getAll = function() { return data.responseData.feed; };

    service.get = function(entryId) { return entries[entryId];  };

    return service;
})

// Settings Data: Settings configuration
.factory('SettingsData', function(){
    var data = {};
    
    data.items = {
        options: [
        {
           name: 'First Option',
           value: true
        }, 
        {
           name: 'Second Option',
           value: false
        }, 
        
        {
           name: 'Third Option',
           value: false
        }],
        sorting: 'A',
        range:30
    };

    return data;
})